package pw.linkr.bukkit.seeya.util;

import lombok.AllArgsConstructor;
import lombok.Getter;

import org.bukkit.entity.Player;

public @Getter @AllArgsConstructor class Permissions {

	private Player player;

	/**
	 * @return if the user is admin or not
	 */
	public boolean isAdmin(){
		return player.isOp() || player.hasPermission("seeya.*");
	}

	/**
	 * @param what
	 * @return whether the user can do something or not
	 */
	public boolean can(String what){
		return isAdmin() || player.hasPermission("seeya." + what.toLowerCase());
	}

	/**
	 * @param what
	 * @return whether the user can punish or not
	 */
	public boolean canPunish(String what){
		return isAdmin() || player.hasPermission("seeya.punish.*") || player.hasPermission("seeya.punish." + what.toLowerCase());
	}

	/**
	 * @return whether the user is exempt from punishment or not
	 */
	public boolean exempt() {
		return canPunish("exempt ");
	}

}
